using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductImages;
namespace CMSMicroservice.Protobuf.Validator.ProductImages;

public class UpdateProductImagesRequestValidator : AbstractValidator<UpdateProductImagesRequest>
{
    public UpdateProductImagesRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.Title)
            .NotEmpty();
        RuleFor(model => model.ImagePath)
            .NotEmpty();
        RuleFor(model => model.ImageThumbnailPath)
            .NotEmpty();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateProductImagesRequest>.CreateWithOptions((UpdateProductImagesRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
